import java.awt.Image;
import java.awt.image.ImageObserver;
import java.awt.image.BufferedImage;

public class BufferedImageFilterAsImageFilter implements ImageFilter {
	private BufferedImageFilter bufImgFilter;
	private BufferedImage imgBuffer;
	
	public BufferedImageFilterAsImageFilter(BufferedImageFilter bufImgFilter) {
		this.bufImgFilter = bufImgFilter;
		this.imgBuffer = null;
	}
	
	public Image createFilteredImage(Image img) {
		int width = img.getWidth(null);
		int height = img.getHeight(null);
		
		// Ensure that the internal BufferedImage is size-compatible
		// with the image to be filtered
		if ((this.imgBuffer == null) ||
			(this.imgBuffer.getWidth() != width) ||
			(this.imgBuffer.getHeight() != height))
		{
			this.imgBuffer = new BufferedImage(
				width,
				height,
				BufferedImage.TYPE_INT_ARGB);
		}
		
		// Copy the data from the original image into the BufferedImage
		imgBuffer.getGraphics().drawImage(img, 0, 0, (ImageObserver) null);
		
		// Filter the image
		bufImgFilter.filter(imgBuffer);
		
		// Return the filtered image
		return imgBuffer;
	}
	
	public String toString() {
		return bufImgFilter.toString();
	}
}